

.include 	"tn2313adef.inc"	;  tiny2313a


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	FlagFazy=R22			;  
.def	CounterByteOZU=R23		;  ,   
.def	Temp8=R24
.def	Temp9=R25


.dseg					;

OZU: .byte 40				;  40   


;******************************************************************************


.cseg			

.org 0


rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

.org INT0addr				; = 0x0001 External Interrupt Request 0

rjmp INT_0

.org INT_VECTORS_SIZE


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b00000001		;   "" (0-, 1-)
	out DDRB,Temp			; 0000000 - ""  
					; 0 - "" 
				
												 
	ldi Temp,0b00000000		;   "D" (0-, 1-)
	out DDRD,Temp 			; 00000000 -     


	RCALL	LCD_INIT		;  




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					
;	ldi R16,(1<<ISC00)		;     INT0    
;	out MCUCR,R16
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




	ldi Temp,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,Temp


	ldi Temp,(1<<INT0)		;     INT0
	out GIMSK ,Temp


	
	ldi Temp,(1<<cs10)		;    = CK 1:1 ( 1   = 1  )
	out TCCR1B,Temp	


	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp




	ldi FlagFazy,2			;   ( 1= , 0= , 2=  )

	ldi CounterByteOZU,80		;    ,   




	sei				;   
	

;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;  
;*******************************************************************************

INT_0:
	



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in Xl,TCNT1L			;     "X"   "TCNT1"
	in Xh,TCNT1H



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp


;***************************************************************************************
;   
;***************************************************************************************


	cpi FlagFazy,2			;         ?
	brne proverka_flaga_fazy	;  ,     "__"

	ldi Temp,(1<<ISC01)		;      "INT0" 
	out MCUCR,Temp

	ldi FlagFazy,0			;    (0= )


					;   "Z"    "OZU"
	ldi ZL,	low(OZU)		;   
	ldi ZH,	high(OZU)		;   

	rjmp out_1			; 



;*****************************************************************************************
;   /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;*****************************************************************************************


proverka_flaga_fazy:

	cpi FlagFazy,0			;      ? (   ? )
	brne setup_falling_edge		;  ,       
					;  ,     




setup_rising_edge:			;  - "    "

	ldi Temp,(1<<ISC01)|(1<<ISC00)	;      "INT0"
	out MCUCR,Temp

	ldi FlagFazy,1			;    (1= )

					;     



;*********************************************************************************
;    TCNT1  3300-10%=2970  ( 0xB9A )
;*********************************************************************************



	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xB			;     "Y" 3300-10%=2970  ( 0xB9A )
	ldi YL,0x9A



	rcall compare_XY16		; ...

	breq X_bolshe_Y_2970_imp	;     X=Y 
	brcs X_menshe_Y_2970_imp	;     X<Y
	rjmp X_bolshe_Y_2970_imp	;     X>Y 





;*****************************************************************************************
;   
;*****************************************************************************************


compare_XY16:

	cp Temp,YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            

;*************************************************************************************************************
;   TCNT1   2970   3630							 x<2970  >3630 ()
;*************************************************************************************************************

X_menshe_Y_2970_imp:			;    TCNT1  2970

X_bolshe_Y_3630_imp:			;    TCNT1  3630


	LDI temp, 0x02			;  "2"    
	RCALL LCD_CHAR			;  



	dec CounterByteOZU		;     

	brne out_1			;    80 ,     !!!!!!!!!!!!!!!!!!!!!!!!!!!!( Relative branch out of reach)

	rjmp chtenie_ozu		;   80,  


;*************************************************************************************************************
;  TCNT1   2970 //      3300+10%=3630  ( 0xE2E )
;*************************************************************************************************************


X_bolshe_Y_2970_imp:			;    TCNT1  2970




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16		; ...

	breq X_menshe_Y_3630_imp	;     X=Y
	brcs X_menshe_Y_3630_imp	;     X<Y 
	rjmp X_bolshe_Y_3630_imp	;     X>Y 



;*************************************************************************************************************
; TCNT1   2970   3630 (    3300 +/- 10% ) 					! x=3300 (  )
;*************************************************************************************************************

X_menshe_Y_3630_imp:			;    TCNT1  2970   3630 
					; (    3300 +/- 10% )



	LDI temp, 0x01			;  "1"    
	RCALL LCD_CHAR			;  

	dec CounterByteOZU		;     

	brne out_1			;    80 ,      !!!!!!!!!!!!!!!!!!(Relative branch out of reach)

	rjmp chtenie_ozu		;   80,  


;**************************************************************************************************************











;*************************************************************************************************************
;   /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
;*************************************************************************************************************

setup_falling_edge:			;  - "    "

	ldi Temp,(1<<ISC01)		;      "INT0"
	out MCUCR,Temp

	ldi FlagFazy,0			;    (0= )

					;    



;*********************************************************************************
;  TCNT1  3300-10%=2970  ( 0xB9A )
;*********************************************************************************



	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xB			;     "Y" 3300-10%=2970  ( 0xB9A )
	ldi YL,0x9A



	rcall compare_XY16		; ...

	breq X_bolshe_Y_2970		;     X=Y 
	brcs X_menshe_Y_2970		;     X<Y
	rjmp X_bolshe_Y_2970		;     X>Y 




;*************************************************************************************************************
;   TCNT1  2970 (    )						! x<2970
;*************************************************************************************************************

X_menshe_Y_2970:			;    TCNT1  2970


	LDI temp, 0x05			;  "5"    
	RCALL LCD_CHAR			;  

	

	dec CounterByteOZU		;     

	brne out_1			;    80 ,    

	rjmp chtenie_ozu		;   80,  


;*************************************************************************************************************
;  TCNT1  2970 //      3300+10%=3630  ( 0xE2E )
;*************************************************************************************************************


X_bolshe_Y_2970:			;    TCNT1  2970




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16		; ...

	breq X_menshe_Y_3630		;     X=Y
	brcs X_menshe_Y_3630		;     X<Y 
	rjmp X_bolshe_Y_3630		;     X>Y 





;*************************************************************************************************************
;   TCNT1  2970   3630 (    3300 +/- 10% ) 				! x=3300
;*************************************************************************************************************

X_menshe_Y_3630:			;    TCNT1  2970   3630 (    3300 +/- 10% )




	LDI temp, 0x04			;  "4"    
	RCALL LCD_CHAR			;  
	
	ldi Temp,1
	st Z+,Temp			;    "", 
 					;     "X"    1


	dec CounterByteOZU		;     

	brne out_1			;    80 ,    

	rjmp chtenie_ozu		;   80,  

;*************************************************************************************************************
; TCNT1  3630 //       6600-10%=5940  ( 0x1734 )
;*************************************************************************************************************


X_bolshe_Y_3630:			;    TCNT1  3630


	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0x17			;     "Y" 6600-10%=5940  ( 0x1734 )
	ldi YL,0x34



	rcall compare_XY16		; ...

	breq X_bolshe_Y_5940		;     X=Y 
	brcs X_menshe_Y_5940		;     X<Y
	rjmp X_bolshe_Y_5940		;     X>Y 



;*************************************************************************************************************
;   TCNT1  3630   5940  (     )						! 3630<x<5940
;*************************************************************************************************************


X_menshe_Y_5940:			;   TCNT1  3630   5940


	LDI temp, 0x06			;  "6"    
	RCALL LCD_CHAR			;  


	dec CounterByteOZU		;     

	brne out_1			;    80 ,    

	rjmp chtenie_ozu		;   80,  


;*************************************************************************************************************
;  TCNT1  5940 //      6600+10%=7260 ( 1C5C )
;*************************************************************************************************************


X_bolshe_Y_5940:			; TCNT1  5940 //      6600+10%=7260 ( 1C5C )




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16		; ...

	breq X_menshe_Y_7260		;     X=Y
	brcs X_menshe_Y_7260		;     X<Y 
	rjmp X_bolshe_Y_7260		;     X>Y 



;*************************************************************************************************************
;   TCNT1  5940,   7260  (     6600 +/- 10% ) 				! x=6600
;*************************************************************************************************************


X_menshe_Y_7260:


	LDI temp, 0x03			;  "3"    
	RCALL LCD_CHAR			;  


	Ldi Temp,0
	st Z+,Temp			;    ""
 					;     "Z"    1


	dec CounterByteOZU		;     

	brne out_1			;    80 ,    

	rjmp chtenie_ozu		;   80,  


;*************************************************************************************************************
;   TCNT1  7260 (    )								! x>7260
;*************************************************************************************************************

X_bolshe_Y_7260:

	LDI temp, 0x07			;  "7"    
	RCALL LCD_CHAR			;  


	dec CounterByteOZU		;     

	brne out_1			;    80 ,    

	rjmp chtenie_ozu		;   80,  


;**************************************************************************************************************
;    
;**************************************************************************************************************

chtenie_ozu:
				;  
	rjmp chtenie_ozu


;**************************************************************************************************************
;    /     
;**************************************************************************************************************

sbros_znachenyi:			;   
					;      !





;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    


;**********************************************************************************************************************


.include "lcd5110mini.asm"		;   	




